/*
 * BoardFrame.java
 *
 * Created on 2004/07/22, 17:08
 */

package gui;
import java.util.*;
import java.text.*;
import javax.swing.table.*;
import board.*;
import webservice.*;
import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 *
 * @author  Kishida
 */
public class BoardFrame extends javax.swing.JFrame {
	BoardManagerIF manager;

	/** Creates new form BoardFrame */
	public BoardFrame() {
		initComponents();

		try{
            manager = new BoardService_Impl().getBoardManagerIFPort();
            BoardManagerIF_Stub stub = (BoardManagerIF_Stub)manager;
            stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY,
                "http://localhost:8084/richclient/jaxrpc/BoardService");
            viewMessageList();  
        }
        catch(Exception e){
            e.printStackTrace();
            System.exit(0);
        }
	}
	
	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtWriter = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        txtMessage = new javax.swing.JTextField();
        btnSubmit = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        tableMessageList = new javax.swing.JTable();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jLabel1.setText("\u540d\u524d");
        jPanel1.add(jLabel1);

        txtWriter.setColumns(10);
        jPanel1.add(txtWriter);

        jLabel2.setText("\u30e1\u30c3\u30bb\u30fc\u30b8");
        jPanel1.add(jLabel2);

        txtMessage.setColumns(15);
        jPanel1.add(txtMessage);

        btnSubmit.setText("\u6295\u7a3f");
        btnSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSubmitActionPerformed(evt);
            }
        });

        jPanel1.add(btnSubmit);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        tableMessageList.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(tableMessageList);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    /** bZ[Wꗗe[uɐݒ
     */
    private void viewMessageList() throws Exception{
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyNMd Hm");
        
        //zɕϊ
        String[][] messages = new String[manager.getMessageList().size()][];
        int i = 0;
        for(Iterator ite = manager.getMessageList().iterator(); ite.hasNext();){
            BoardMessage message = (BoardMessage)ite.next();
            messages[i++] = new String[]{
                sdf.format(message.getWriteDate()),
                message.getWriter(),
                message.getMessage()
            };
        }
		int y = 3;
		byte x = 3+2;
        //e[uɐݒ
        tableMessageList.setModel(
            new DefaultTableModel(messages,
                                  new String[]{"t","O","bZ[W"}));
    }

	private void btnSubmitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSubmitActionPerformed
        try{
            String writer = txtWriter.getText();
            String message = txtMessage.getText();
            manager.addMessage(writer, message);
            viewMessageList();
        }catch(Exception e){e.printStackTrace();}
	}//GEN-LAST:event_btnSubmitActionPerformed
	
	/** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
		System.exit(0);
	}//GEN-LAST:event_exitForm
	
	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		new BoardFrame().show();
	}
	
    // ϐ錾 - ҏWs//GEN-BEGIN:variables
    private javax.swing.JButton btnSubmit;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tableMessageList;
    private javax.swing.JTextField txtMessage;
    private javax.swing.JTextField txtWriter;
    // ϐ錾̏I//GEN-END:variables
	
}
